import {
  PLazy
} from "../../chunks/chunk-IKINPSS5.js";
import "../../chunks/chunk-U5RRZUYZ.js";

// src/adapter/test/TestCMS.tsx
import { memoryBackend } from "alinea/backend/data/MemoryBackend";
import { Database } from "alinea/backend/Database";
import { createHandler } from "alinea/backend/Handler";
import { createStore } from "alinea/backend/store/CreateStore";
import { CMS } from "alinea/core/CMS";
import { createConfig } from "alinea/core/Config";
import { createId } from "alinea/core/Id";
import { localUser } from "alinea/core/User";
function createCMS(definition) {
  const config = createConfig(definition);
  const store = createStore();
  const db = store.then(async (store2) => {
    const db2 = new Database(config, store2);
    await db2.fill({ async *entries() {
    } }, "");
    return db2;
  });
  const backend = db.then(
    (db2) => ({
      ...memoryBackend(db2),
      target: {
        async mutate(ctx, params) {
          return { commitHash: createId() };
        }
      },
      media: {
        async prepareUpload(ctx, file) {
          const id = createId();
          const serve = await listenForUpload();
          return {
            entryId: createId(),
            location: `media/${file}_${id}`,
            previewUrl: `media/${file}_${id}`,
            url: serve.url
          };
        }
      }
    })
  );
  const handle = PLazy.from(async () => {
    return createHandler(cms, await backend, db);
  });
  const cms = new CMS(config, async () => {
    const { connect } = await handle;
    return connect({
      handlerUrl: new URL("http://localhost:3000"),
      apiKey: "dev",
      user: localUser,
      token: ""
    });
  });
  return Object.assign(cms, { db });
}
async function listenForUpload() {
  const { createServer } = await import("http");
  const server = createServer((req, res) => {
    res.end();
    server.close();
  });
  return new Promise((resolve) => {
    server.listen(0, () => {
      resolve({
        url: `http://localhost:${server.address().port}`
      });
    });
  });
}
export {
  createCMS
};
