import { Database } from 'alinea/backend/Database';
import { CMS } from 'alinea/core/CMS';
import { Connection } from 'alinea/core/Connection';
import { AuthedContext, Backend, RequestContext } from './Backend.js';
export interface Handler {
    (request: Request, context?: RequestContext): Promise<Response>;
}
export interface HandlerWithConnect {
    (request: Request, context: RequestContext): Promise<Response>;
    connect(context: RequestContext | AuthedContext): Connection;
}
export declare function createHandler(cms: CMS, backend?: Backend, database?: Promise<Database>): HandlerWithConnect;
