import { Backend } from 'alinea/backend/Backend';
import * as driver from 'rado/driver';
import { GithubOptions } from './GithubApi.js';
export type AvailableDrivers = 'd1' | 'mysql2' | '@neondatabase/serverless' | '@vercel/postgres' | 'pg' | '@electric-sql/pglite' | 'sql.js' | '@libsql/client';
export interface BackendOptions<Driver extends AvailableDrivers> {
    auth(username: string, password: string): boolean | Promise<boolean>;
    database: {
        driver: Driver;
        client: Parameters<(typeof driver)[Driver]>[0];
    };
    github: GithubOptions;
}
export declare function createBackend<Driver extends AvailableDrivers>(options: BackendOptions<Driver>): Backend;
