import "../../chunks/chunk-U5RRZUYZ.js";

// src/backend/data/MemoryBackend.ts
import { MemoryDrafts } from "alinea/cli/serve/MemoryDrafts";
import { createId } from "alinea/core/Id";
import { localUser } from "alinea/core/User";
function memoryBackend(db) {
  const pending = [];
  const auth = {
    async authenticate() {
      return new Response("ok");
    },
    async verify(ctx) {
      return { ...ctx, user: localUser, token: "dev" };
    }
  };
  const target = {
    async mutate(ctx, params) {
      const mutations = params.mutations.flatMap((mutate) => mutate.meta);
      const toCommitHash = createId();
      await db.applyMutations(mutations, toCommitHash);
      pending.push({ ...params, toCommitHash });
      return { commitHash: toCommitHash };
    }
  };
  const media = {
    prepareUpload(ctx, file) {
      throw new Error(`Not implemented`);
    }
  };
  const drafts = new MemoryDrafts();
  const history = {
    async list(ctx, file) {
      return [];
    },
    async revision(ctx, file, ref) {
      throw new Error(`Not implemented`);
    }
  };
  return {
    auth,
    target,
    media,
    drafts,
    history
  };
}
export {
  memoryBackend
};
