import type { Projection } from 'alinea/core/pages/Projection';
import { Realm } from 'alinea/core/pages/Realm';
import DataLoader from 'dataloader';
import { Store } from '../Store.js';
import type { EntryResolver } from './EntryResolver.js';
export declare class LinkResolver {
    resolver: EntryResolver;
    store: Store;
    realm: Realm;
    loaders: Map<Projection, DataLoader<string, object, string>>;
    constructor(resolver: EntryResolver, store: Store, realm: Realm);
    load(projection: Projection): DataLoader<string, object, string>;
    resolveLinks<P extends Projection>(projection: P, entryIds: ReadonlyArray<string>): Promise<Array<Projection.Infer<P> | undefined>>;
}
