import { EntryRow } from 'alinea/core/EntryRow';
import { Realm } from 'alinea/core/pages/Realm';
interface ResolveContextData {
    realm: Realm;
    location: Array<string>;
    locale: string | undefined;
    depth: number;
    expr: ExprContext;
}
declare enum ExprContext {
    InNone = 0,
    InSelect = 1,
    InCondition = 2,
    InAccess = 4
}
export declare class ResolveContext {
    private data;
    table: typeof EntryRow;
    constructor(data: Partial<ResolveContextData>);
    linkContext(): ResolveContext;
    get depth(): number;
    get location(): string[];
    get realm(): Realm;
    get locale(): string | undefined;
    get expr(): ExprContext;
    get Table(): import("rado").Table<{
        entryId: import("rado").Column<string>;
        phase: import("rado").Column<import("alinea/core/EntryRow").EntryPhase>;
        title: import("rado").RequiredColumn<string | null>;
        type: import("rado").RequiredColumn<string | null>;
        seeded: import("rado").Column<string | null>;
        workspace: import("rado").RequiredColumn<string | null>;
        root: import("rado").RequiredColumn<string | null>;
        index: import("rado").RequiredColumn<string | null>;
        parent: import("rado").Column<string | null>;
        i18nId: import("rado").RequiredColumn<string | null>;
        locale: import("rado").Column<string | null>;
        active: import("rado").RequiredColumn<boolean | null>;
        main: import("rado").RequiredColumn<boolean | null>;
        path: import("rado").RequiredColumn<string | null>;
        data: import("rado").Column<any>;
        level: import("rado").RequiredColumn<number | null>;
        filePath: import("rado").RequiredColumn<string | null>;
        parentDir: import("rado").RequiredColumn<string | null>;
        childrenDir: import("rado").RequiredColumn<string | null>;
        modifiedAt: import("rado").RequiredColumn<number | null>;
        rowHash: import("rado").RequiredColumn<string | null>;
        fileHash: import("rado").RequiredColumn<string | null>;
        url: import("rado").RequiredColumn<string | null>;
        searchableText: import("rado").RequiredColumn<string | null>;
    }, "Entry">;
    increaseDepth(): ResolveContext;
    decreaseDepth(): ResolveContext;
    get isInSelect(): number;
    get isInCondition(): number;
    get isInAccess(): number;
    get select(): ResolveContext;
    get condition(): ResolveContext;
    get access(): ResolveContext;
    get none(): ResolveContext;
}
export {};
