export declare function createExample(): import("alinea/core/CMS").CMS<{
    schema: {
        Fields: import("alinea/core/Type").Type<import("alinea/core/Document").Document<{
            text: import("alinea/field/text").TextField;
            hello: import("alinea/field/text").TextField;
            richText: import("alinea/core").RichTextField<{}, import("alinea/field/richtext").RichTextOptions<{}>>;
            select: import("alinea/field/select").SelectField<"a" | "b">;
            number: import("alinea/field/number").NumberField;
            check: import("alinea/field/check").CheckField;
            date: import("alinea/field/date").DateField;
            code: import("alinea/field/code").CodeField;
            externalLink: import("alinea/field/link/LinkField").LinkField<import("alinea/alinea").UrlReference, import("alinea/alinea").UrlLink<{}>>;
            entry: import("alinea/field/link/LinkField").LinkField<import("alinea/alinea").EntryReference, import("alinea/alinea").EntryLink<undefined>>;
            entryWithCondition: import("alinea/field/link/LinkField").LinkField<import("alinea/alinea").EntryReference, import("alinea/alinea").EntryLink<undefined>>;
            linkMultiple: import("alinea/field/link/LinkField").LinksField<import("alinea/core/shape/ListShape").ListRow, import("alinea/types").AnyLink<{}>>;
            image: import("alinea/field/link").ImageField<undefined>;
            images: import("alinea/field/link").ImagesField<undefined>;
            file: import("alinea/field/link/LinkField").LinkField<import("alinea/alinea").EntryReference, import("alinea/alinea").EntryLink<undefined>>;
            withFields: import("alinea/field/link/LinkField").LinkField<import("alinea/core/Reference").Reference, import("alinea/types").AnyLink<{
                fieldA: string;
                fieldB: string;
            }>>;
            multipleWithFields: import("alinea/field/link/LinkField").LinksField<import("alinea/core/shape/ListShape").ListRow, import("alinea/types").AnyLink<{
                fieldA: string;
                fieldB: string;
            }>>;
            list: import("alinea/core").ListField<({
                _type: "Image";
                image: import("alinea/alinea").EntryReference;
            } | {
                _type: "Text";
                title: string;
                text: import("alinea/alinea").TextDoc<{}>;
            }) & import("alinea/core/shape/ListShape").ListRow, ({
                _type: "Image";
                image: import("alinea/alinea").ImageLink<undefined>;
            } | {
                _type: "Text";
                title: string;
                text: import("alinea/alinea").TextDoc<{}>;
            }) & import("alinea/core/shape/ListShape").ListRow, import("alinea/field/list").ListOptions<{
                Text: import("alinea/core/Type").Type<{
                    title: import("alinea/field/text").TextField;
                    text: import("alinea/core").RichTextField<{}, import("alinea/field/richtext").RichTextOptions<{}>>;
                }>;
                Image: import("alinea/core/Type").Type<{
                    image: import("alinea/field/link").ImageField<undefined>;
                }>;
            }>>;
            withInitial: import("alinea/core").RichTextField<{}, import("alinea/field/richtext").RichTextOptions<{}>>;
            nested: import("alinea/core").RichTextField<{
                Inner: import("alinea/core/Type").Type<{
                    checkbox1: import("alinea/field/check").CheckField;
                    checkbox2: import("alinea/field/check").CheckField;
                    title: import("alinea/field/text").TextField;
                    content: import("alinea/core").RichTextField<{}, import("alinea/field/richtext").RichTextOptions<{}>>;
                }>;
                NestLayout: import("alinea/core/Type").Type<{
                    tabA: import("alinea/field/text").TextField;
                    tabB: import("alinea/field/text").TextField;
                    object: import("alinea/field/object").ObjectField<{
                        fieldA: import("alinea/field/text").TextField;
                        fieldB: import("alinea/field/text").TextField;
                    }>;
                }>;
            }, import("alinea/field/richtext").RichTextOptions<{
                Inner: import("alinea/core/Type").Type<{
                    checkbox1: import("alinea/field/check").CheckField;
                    checkbox2: import("alinea/field/check").CheckField;
                    title: import("alinea/field/text").TextField;
                    content: import("alinea/core").RichTextField<{}, import("alinea/field/richtext").RichTextOptions<{}>>;
                }>;
                NestLayout: import("alinea/core/Type").Type<{
                    tabA: import("alinea/field/text").TextField;
                    tabB: import("alinea/field/text").TextField;
                    object: import("alinea/field/object").ObjectField<{
                        fieldA: import("alinea/field/text").TextField;
                        fieldB: import("alinea/field/text").TextField;
                    }>;
                }>;
            }>>;
        }>>;
        Page: import("alinea/core/Type").Type<{
            name: import("alinea/field/path").PathField & import("alinea/field/text").TextField;
            name2: import("alinea/field/text").TextField;
            title: import("alinea/field/text").TextField;
            path: import("alinea/field/path").PathField;
        }>;
        Container: import("alinea/core/Type").Type<{
            title: import("alinea/field/text").TextField;
            path: import("alinea/field/path").PathField;
            name: import("alinea/field/text").TextField;
        }>;
    };
    workspaces: {
        main: import("alinea/core/Workspace").Workspace<{
            pages: import("alinea/core/Root").Root<{
                entry1: import("alinea/core/Page").PageSeed<{
                    name: import("alinea/field/path").PathField & import("alinea/field/text").TextField;
                    name2: import("alinea/field/text").TextField;
                    title: import("alinea/field/text").TextField;
                    path: import("alinea/field/path").PathField;
                }, Record<string, any>>;
                entry2: import("alinea/core/Page").PageSeed<{
                    title: import("alinea/field/text").TextField;
                    path: import("alinea/field/path").PathField;
                    name: import("alinea/field/text").TextField;
                }, Record<string, any>>;
                container1: import("alinea/core/Page").PageSeed<{
                    title: import("alinea/field/text").TextField;
                    path: import("alinea/field/path").PathField;
                    name: import("alinea/field/text").TextField;
                }, Record<string, any>>;
            }>;
            multiLanguage: import("alinea/core/Root").Root<{
                localised1: import("alinea/core/Page").PageSeed<{
                    name: import("alinea/field/path").PathField & import("alinea/field/text").TextField;
                    name2: import("alinea/field/text").TextField;
                    title: import("alinea/field/text").TextField;
                    path: import("alinea/field/path").PathField;
                }, Record<string, any>>;
                localised2: import("alinea/core/Page").PageSeed<{
                    title: import("alinea/field/text").TextField;
                    path: import("alinea/field/path").PathField;
                    name: import("alinea/field/text").TextField;
                }, Record<string, any>>;
            }>;
            media: import("alinea/core/media/MediaRoot").MediaRoot<{
                dir: import("alinea/core/Page").PageSeed<{
                    title: import("alinea/field/hidden").HiddenField<string>;
                    path: import("alinea/field/hidden").HiddenField<string>;
                }, Record<string, any>>;
                'file1.png': import("alinea/core/Page").PageSeed<{
                    title: import("alinea/field/text").TextField;
                    path: import("alinea/field/hidden").HiddenField<string>;
                    location: import("alinea/field/hidden").HiddenField<string>;
                    extension: import("alinea/field/hidden").HiddenField<string>;
                    size: import("alinea/field/hidden").HiddenField<number>;
                    hash: import("alinea/field/hidden").HiddenField<string>;
                    width: import("alinea/field/hidden").HiddenField<number>;
                    height: import("alinea/field/hidden").HiddenField<number>;
                    preview: import("alinea/field/hidden").HiddenField<string>;
                    averageColor: import("alinea/field/hidden").HiddenField<string>;
                    focus: import("alinea/field/hidden").HiddenField<{
                        x: number;
                        y: number;
                    }>;
                    thumbHash: import("alinea/field/hidden").HiddenField<string>;
                }, Record<string, any>>;
            }>;
        }>;
    };
}> & {
    db: Promise<import("../Database").Database>;
};
