export declare class DeepMap<Keys extends ReadonlyArray<any>, V> {
    #private;
    constructor(entries?: ReadonlyArray<readonly [Keys, V]> | null);
    get size(): number;
    set(keys: Keys, value: V): this;
    clear(): void;
    delete(keys: Keys): boolean;
    has(keys: Keys): boolean;
    get(keys: Keys): V | undefined;
    values(): IterableIterator<V>;
    keys(): IterableIterator<Keys>;
    entries(): IterableIterator<[Keys, V]>;
    [Symbol.iterator](): IterableIterator<[Keys, V]>;
}
