import "../../chunks/chunk-U5RRZUYZ.js";

// src/backend/util/JsonPatch.ts
function applyJsonPatch(source, patch) {
  if (!patch || typeof patch !== "object")
    return source;
  for (const [key, value] of Object.entries(patch)) {
    if (value && typeof value === "object" && !Array.isArray(value)) {
      if (!source[key])
        source[key] = {};
      applyJsonPatch(source[key], value);
    } else {
      if (value === null)
        delete source[key];
      else
        source[key] = value;
    }
  }
  return source;
}
export {
  applyJsonPatch
};
