// node_modules/lib0/math.js
var floor = Math.floor;
var abs = Math.abs;
var min = (a, b) => a < b ? a : b;
var max = (a, b) => a > b ? a : b;
var isNaN = Number.isNaN;
var isNegativeZero = (n) => n !== 0 ? n < 0 : 1 / n < 0;

// node_modules/lib0/error.js
var create = (s) => new Error(s);
var methodUnimplemented = () => {
  throw create("Method unimplemented");
};
var unexpectedCase = () => {
  throw create("Unexpected case");
};

export {
  floor,
  abs,
  min,
  max,
  isNegativeZero,
  create,
  methodUnimplemented,
  unexpectedCase
};
