import {
  input
} from "./chunk-AOFVF5VC.js";
import {
  getData,
  getField,
  internalData,
  sql
} from "./chunk-NXCD6SNE.js";

// node_modules/rado/dist/core/Column.js
var Column = class _Column {
  [internalData];
  constructor(data) {
    this[internalData] = data;
  }
  notNull() {
    return new _Column({
      ...getData(this),
      notNull: true
    });
  }
  $defaultFn(value) {
    return this.$default(value);
  }
  $default(value) {
    return new _Column({
      ...getData(this),
      $default() {
        return input(value instanceof Function ? value() : value);
      }
    });
  }
  default(value) {
    return new _Column({
      ...getData(this),
      defaultValue: input(value)
    });
  }
  defaultNow() {
    return new _Column({
      ...getData(this),
      defaultValue: sql.unsafe("now()")
    });
  }
  primaryKey() {
    return new _Column({ ...getData(this), primary: true });
  }
  unique(name) {
    return new _Column({ ...getData(this), isUnique: true });
  }
  references(foreignField) {
    return new _Column({
      ...getData(this),
      references() {
        return getField(
          typeof foreignField === "function" ? foreignField() : foreignField
        );
      }
    });
  }
  $type() {
    return this;
  }
};
var JsonColumn = class extends Column {
  constructor(data) {
    super({ ...data, json: true });
  }
};
function createColumn(data) {
  return new Column(data);
}
var column = new Proxy(createColumn, {
  get(target, method) {
    return target[method] ??= (...args) => {
      while (args.length > 0)
        if (args.at(-1) === void 0)
          args.pop();
        else
          break;
      if (args.length === 0)
        return sql.unsafe(method);
      return sql`${sql.unsafe(method)}(${sql.join(
        args.map(sql.inline),
        sql`, `
      )})`;
    };
  }
});

export {
  JsonColumn,
  column
};
