import "../../chunks/chunk-U5RRZUYZ.js";

// src/cli/generate/CopyStaticFiles.ts
import { createId } from "alinea/core/Id";
import fs from "node:fs/promises";
import path from "node:path";
import { writeFileIfContentsDiffer } from "../util/FS.js";
var packageJson = {
  private: true,
  version: "0.0.0",
  name: "@alinea/generated",
  type: "module",
  sideEffects: false
};
async function copyStaticFiles({ outDir }) {
  await fs.mkdir(outDir, { recursive: true }).catch(console.log);
  await fs.writeFile(
    path.join(outDir, "release.js"),
    `export const release = ${JSON.stringify(createId())}`
  );
  await fs.writeFile(
    path.join(outDir, "package.json"),
    JSON.stringify(packageJson, null, 2)
  );
  await writeFileIfContentsDiffer(path.join(outDir, "views.css"), ``);
  await writeFileIfContentsDiffer(
    path.join(outDir, ".keep"),
    "# Contents of this folder are autogenerated by alinea"
  );
}
export {
  copyStaticFiles
};
