import {
  pLimit
} from "../../chunks/chunk-QQTYTFWR.js";
import "../../chunks/chunk-U5RRZUYZ.js";

// src/cli/generate/FillCache.ts
import { Database } from "alinea/backend/Database";
import { getCommitSha } from "../util/CommitSha.js";
import { createEmitter } from "../util/Emitter.js";
import { createWatcher } from "../util/Watcher.js";
var dbCache = /* @__PURE__ */ new WeakMap();
function fillCache({ fix }, localData, store, config) {
  let canceled = false;
  let stopWatching = () => {
    canceled = true;
  };
  const results = createEmitter({
    onReturn() {
      stopWatching();
    }
  });
  const run = () => limit(cache).then(results.emit, results.throw);
  const db = dbCache.has(config) ? dbCache.get(config) : new Database(config, store);
  dbCache.set(config, db);
  const limit = pLimit(1);
  const commitSha = getCommitSha();
  const cache = async () => {
    await db.fill(localData, commitSha ?? "", localData, fix);
    return db;
  };
  createWatcher({
    watchFiles: localData.watchFiles.bind(localData),
    onChange: run
  }).then((cancel) => {
    if (canceled)
      cancel();
    else
      stopWatching = cancel;
  });
  run();
  return results;
}
export {
  fillCache
};
