import "../../chunks/chunk-U5RRZUYZ.js";

// src/cli/generate/LoadConfig.ts
import { CMS } from "alinea/core/CMS";
import { createRequire } from "node:module";
import path from "node:path";
import { pathToFileURL } from "node:url";
async function loadCMS(outDir) {
  const unique = Date.now();
  const genConfigFile = path.join(outDir, "config.js");
  const outFile = `${pathToFileURL(genConfigFile)}?${unique}`;
  global.require = createRequire(import.meta.url);
  const exports = await import(outFile);
  if ("cms" in exports && exports.cms instanceof CMS)
    return exports.cms;
  if ("default" in exports)
    throw new Error(`No export named cms found, did you export it as default?`);
  throw new Error(`No export named cms found`);
}
export {
  loadCMS
};
