import { AuthedContext, Media, Target } from 'alinea/backend/Backend';
import { FS } from 'alinea/backend/FS';
import { Source, SourceEntry, WatchFiles } from 'alinea/backend/Source';
import { Config } from 'alinea/core/Config';
import { Connection } from 'alinea/core/Connection';
export interface LocalDataOptions {
    config: Config;
    fs: FS;
    rootDir?: string;
    dashboardUrl?: string;
}
export declare class LocalData implements Source, Target, Media {
    options: LocalDataOptions;
    constructor(options: LocalDataOptions);
    watchFiles(): Promise<WatchFiles>;
    entries(): AsyncGenerator<SourceEntry>;
    mutate(ctx: AuthedContext, { mutations }: Connection.MutateParams): Promise<{
        commitHash: string;
    }>;
    isInMediaLocation(file: string): boolean;
    prepareUpload(ctx: AuthedContext, file: string): Promise<Connection.UploadResponse>;
}
