import { Config } from './Config.js';
import { Connection } from './Connection.js';
import { Graph, GraphRealm } from './Graph.js';
import { MediaFile, MediaLibrary } from './media/MediaTypes.js';
import { PreviewRequest } from './Resolver.js';
import { Operation } from './Transaction.js';
export interface ConnectionContext {
    apiKey?: string;
    accessToken?: string;
    preview?: PreviewRequest;
}
export declare class CMS<Definition extends Config = Config> extends GraphRealm {
    graph: Graph;
    config: Definition;
    connect: () => Promise<Connection>;
    constructor(config: Definition, connect: () => Promise<Connection>);
    commit(...operations: Array<Operation>): Promise<{
        commitHash: string;
    }>;
    get schema(): Definition['schema'] & {
        MediaFile: typeof MediaFile;
        MediaLibrary: typeof MediaLibrary;
    };
    get workspaces(): Definition['workspaces'];
}
