import "../chunks/chunk-U5RRZUYZ.js";

// src/core/CMS.ts
import { createConfig } from "./Config.js";
import { Graph, GraphRealm } from "./Graph.js";
import { Operation } from "./Transaction.js";
var CMS = class extends GraphRealm {
  graph;
  config;
  connect;
  constructor(config, connect) {
    const normalizedConfig = createConfig(config);
    const resolver = {
      resolve: async (params) => {
        const connection = await connect();
        return connection.resolve(params);
      }
    };
    super(normalizedConfig, resolver);
    this.connect = connect;
    this.config = normalizedConfig;
    this.graph = new Graph(normalizedConfig, resolver);
  }
  async commit(...operations) {
    const mutations = await Promise.all(
      operations.flatMap((op) => op[Operation.Data](this))
    );
    const cnx = await this.connect();
    return cnx.mutate(mutations.flat());
  }
  get schema() {
    return this.config.schema;
  }
  get workspaces() {
    return this.config.workspaces;
  }
};
export {
  CMS
};
