import {
  Doc
} from "../chunks/chunk-BWVXXM6J.js";
import "../chunks/chunk-FFKU477P.js";
import "../chunks/chunk-IOTY7UTU.js";
import "../chunks/chunk-BRTZLYIM.js";
import "../chunks/chunk-U5RRZUYZ.js";

// src/core/Doc.ts
import { Field } from "./Field.js";
import { Type } from "./Type.js";
import { entries } from "./util/Objects.js";
var ROOT_KEY = "#root";
function createYDoc(type, entry) {
  const doc = new Doc({ gc: false });
  if (entry)
    applyEntryData(doc, type, entry);
  return doc;
}
function applyEntryData(doc, type, entry) {
  const clientID = doc.clientID;
  doc.clientID = 1;
  doc.transact(() => {
    const docRoot = doc.getMap(ROOT_KEY);
    for (const [key, field] of entries(type)) {
      if (key === "path")
        continue;
      const contents = entry.data[key];
      docRoot.set(key, Field.shape(field).toY(contents));
    }
  });
  doc.clientID = clientID;
}
function parseYDoc(type, doc) {
  const docRoot = doc.getMap(ROOT_KEY);
  const data = Type.shape(type).fromY(docRoot);
  return {
    path: data.path,
    title: data.title,
    data
  };
}
export {
  ROOT_KEY,
  applyEntryData,
  createYDoc,
  parseYDoc
};
