import "../chunks/chunk-U5RRZUYZ.js";

// src/core/Document.ts
import { metadata as createMetadata } from "alinea/field/metadata";
import { path as createPath } from "alinea/field/path";
import { tab, tabs } from "alinea/field/tabs";
import { text } from "alinea/field/text";
import { IcRoundDescription } from "alinea/ui/icons/IcRoundDescription";
import { IcRoundShare } from "alinea/ui/icons/IcRoundShare";
import {
  parseTypeParams,
  type
} from "./Type.js";
var Document;
((Document2) => {
  Document2.title = text("Title", { required: true, width: 0.5 });
  Document2.path = createPath("Path", { required: true, width: 0.5 });
  Document2.metadata = createMetadata();
})(Document || (Document = {}));
function document(label, definition) {
  const { definition: d, options } = parseTypeParams(definition);
  return type(label, {
    ...options,
    fields: {
      ...tabs(
        tab("Document", {
          icon: IcRoundDescription,
          fields: {
            title: Document.title,
            path: Document.path,
            ...d
          }
        }),
        tab("Metadata", {
          icon: IcRoundShare,
          fields: {
            metadata: Document.metadata
          }
        })
      )
      // Todo: Fix type
    }
  });
}
export {
  Document,
  document
};
