import { File } from '@alinea/iso';
import { LinkEditor, LinksEditor } from 'alinea/field/link/LinkEditor';
import { LinkField, LinksField } from 'alinea/field/link/LinkField';
import type { Entry } from './Entry.js';
import { Reference } from './Reference.js';
import { TextDoc } from './TextDoc.js';
import { CreateOperation, DeleteOp, EditOperation, UploadOperation, UploadOptions } from './Transaction.js';
import { Type } from './Type.js';
import { ListEditor, ListField } from './field/ListField.js';
import { RichTextEditor, RichTextField } from './field/RichTextField.js';
import type { ListRow } from './shape/ListShape';
export declare function update<Definition>(entryId: string, type?: Type<Definition>): EditOperation<Definition>;
export declare function create<Definition>(type: Type<Definition>): CreateOperation<Definition>;
export declare function createEntry(entry: Entry): CreateOperation<unknown>;
export declare function remove(entryId: string): DeleteOp;
export declare function upload(file: File | [string, Uint8Array], options?: UploadOptions): UploadOperation;
export declare function archive(entryId: string): EditOperation<unknown>;
export declare function publish(entryId: string): EditOperation<unknown>;
export declare function list<StoredValue extends ListRow, QueryValue extends ListRow>(field: ListField<StoredValue, QueryValue, any>, current?: Array<StoredValue>): ListEditor<StoredValue>;
export declare function richText<Blocks = unknown>(field?: RichTextField<Blocks, any>, current?: TextDoc<Blocks>): RichTextEditor<Blocks>;
export declare function link<StoredValue extends Reference, QueryValue>(field: LinkField<StoredValue, QueryValue>): LinkEditor<StoredValue>;
export declare function links<StoredValue extends ListRow, QueryValue>(field: LinksField<StoredValue, QueryValue>): LinksEditor<StoredValue>;
