import "../chunks/chunk-U5RRZUYZ.js";

// src/core/Edit.ts
import { LinkEditor, LinksEditor } from "alinea/field/link/LinkEditor";
import {
  CreateOperation,
  DeleteOp,
  EditOperation,
  UploadOperation
} from "./Transaction.js";
import { ListEditor } from "./field/ListField.js";
import { RichTextEditor } from "./field/RichTextField.js";
function update(entryId, type) {
  return new EditOperation(entryId);
}
function create(type) {
  return new CreateOperation({}, type);
}
function createEntry(entry) {
  return new CreateOperation(entry);
}
function remove(entryId) {
  return new DeleteOp(entryId);
}
function upload(file, options) {
  return new UploadOperation(file, options);
}
function archive(entryId) {
  return update(entryId).archive();
}
function publish(entryId) {
  return update(entryId).publish();
}
function list(field, current) {
  return new ListEditor(current);
}
function richText(field, current) {
  return new RichTextEditor(current);
}
function link(field) {
  return new LinkEditor();
}
function links(field) {
  return new LinksEditor();
}
export {
  archive,
  create,
  createEntry,
  link,
  links,
  list,
  publish,
  remove,
  richText,
  update,
  upload
};
