import { EntryPhase } from './EntryRow.js';
import { Target } from './pages/Target.js';
export interface Entry {
    entryId: string;
    phase: EntryPhase;
    title: string;
    type: string;
    seeded: string | null;
    workspace: string;
    root: string;
    level: number;
    filePath: string;
    parentDir: string;
    childrenDir: string;
    index: string;
    parent: string | null;
    i18nId: string;
    locale: string | null;
    modifiedAt: number;
    rowHash: string;
    active: boolean;
    main: boolean;
    path: string;
    fileHash: string;
    url: string;
    data: Record<string, any>;
    searchableText: string;
}
export declare const Entry: Target<Entry>;
