import { EntryRow } from './EntryRow.js';
export declare const META_KEY = "@alinea";
export interface EntryMeta {
    _id: string;
    _type: string;
    _index: string;
    _i18nId?: string;
    _root?: string;
    _seeded?: string;
}
export interface EntryRecord extends EntryMeta {
    [field: string]: unknown;
    [META_KEY]?: OldMeta;
}
export declare namespace EntryRecord {
    const id = "_id";
    const type = "_type";
    const index = "_index";
    const i18nId = "_i18nId";
    const root = "_root";
    const seeded = "_seeded";
}
interface OldMeta {
    entryId: string;
    type: string;
    index: string;
    i18nId?: string;
    root?: string;
    seeded?: string;
}
export interface RequiredEntryFields extends Partial<EntryRow> {
    entryId: string;
    type: string;
    index: string;
    data: Record<string, any>;
}
export declare function parseRecord(record: EntryRecord): {
    meta: {
        entryId: string;
        type: string;
        index: string;
        i18nId: string;
        root: string;
        seeded: string;
    };
    data: {
        [field: string]: unknown;
    };
};
export declare function createRecord(entry: RequiredEntryFields): EntryRecord;
export {};
