import "../chunks/chunk-U5RRZUYZ.js";

// src/core/EntryRecord.ts
var META_KEY = "@alinea";
var EntryRecord;
((EntryRecord2) => {
  EntryRecord2.id = "_id";
  EntryRecord2.type = "_type";
  EntryRecord2.index = "_index";
  EntryRecord2.i18nId = "_i18nId";
  EntryRecord2.root = "_root";
  EntryRecord2.seeded = "_seeded";
})(EntryRecord || (EntryRecord = {}));
function parseRecord(record) {
  const oldest = record.alinea;
  const {
    [META_KEY]: old,
    [EntryRecord.id]: entryId = old?.entryId ?? record.id,
    [EntryRecord.type]: type = old?.type ?? record.type,
    [EntryRecord.index]: index = old?.index ?? oldest?.index,
    [EntryRecord.i18nId]: i18nId = old?.i18nId ?? oldest?.i18nId,
    [EntryRecord.root]: root = old?.root ?? oldest?.root,
    [EntryRecord.seeded]: seeded = old?.seeded ?? oldest?.seeded,
    ...data
  } = record;
  return {
    meta: {
      entryId,
      type,
      index,
      i18nId,
      root,
      seeded
    },
    data
  };
}
function createRecord(entry) {
  const { path = entry.path, title = entry.title, ...data } = entry.data;
  const meta = {
    [EntryRecord.id]: entry.entryId,
    [EntryRecord.type]: entry.type,
    [EntryRecord.index]: entry.index,
    [EntryRecord.i18nId]: entry.i18nId
  };
  if (entry.seeded)
    meta[EntryRecord.seeded] = entry.seeded;
  if (entry.locale && entry.i18nId)
    meta[EntryRecord.i18nId] = entry.i18nId;
  if (!entry.parent)
    meta[EntryRecord.root] = entry.root;
  return {
    ...meta,
    title,
    // path,
    ...data
  };
}
export {
  EntryRecord,
  META_KEY,
  createRecord,
  parseRecord
};
