import { InferSelectModel, Sql } from 'rado';
import { Input } from 'rado/core/expr/Input';
export declare enum EntryPhase {
    Draft = "draft",
    Published = "published",
    Archived = "archived"
}
export declare const ALT_STATUS: Array<EntryPhase>;
export type EntryLinks = {
    [field: string]: Array<string>;
};
export declare const EntryRow: import("rado").Table<{
    entryId: import("rado").Column<string>;
    phase: import("rado").Column<EntryPhase>;
    title: import("rado").RequiredColumn<string | null>;
    type: import("rado").RequiredColumn<string | null>;
    seeded: import("rado").Column<string | null>;
    workspace: import("rado").RequiredColumn<string | null>;
    root: import("rado").RequiredColumn<string | null>;
    index: import("rado").RequiredColumn<string | null>;
    parent: import("rado").Column<string | null>;
    i18nId: import("rado").RequiredColumn<string | null>;
    locale: import("rado").Column<string | null>;
    active: import("rado").RequiredColumn<boolean | null>;
    main: import("rado").RequiredColumn<boolean | null>;
    path: import("rado").RequiredColumn<string | null>;
    data: import("rado").Column<any>;
    level: import("rado").RequiredColumn<number | null>;
    filePath: import("rado").RequiredColumn<string | null>;
    parentDir: import("rado").RequiredColumn<string | null>;
    childrenDir: import("rado").RequiredColumn<string | null>;
    /** @deprecated */
    modifiedAt: import("rado").RequiredColumn<number | null>;
    rowHash: import("rado").RequiredColumn<string | null>;
    fileHash: import("rado").RequiredColumn<string | null>;
    url: import("rado").RequiredColumn<string | null>;
    searchableText: import("rado").RequiredColumn<string | null>;
}, "Entry">;
export declare function concat(...slices: Array<Input<string | null>>): Sql<string>;
export declare function entryVersionId(entry?: import("rado").Table<{
    entryId: import("rado").Column<string>;
    phase: import("rado").Column<EntryPhase>;
    title: import("rado").RequiredColumn<string | null>;
    type: import("rado").RequiredColumn<string | null>;
    seeded: import("rado").Column<string | null>;
    workspace: import("rado").RequiredColumn<string | null>;
    root: import("rado").RequiredColumn<string | null>;
    index: import("rado").RequiredColumn<string | null>;
    parent: import("rado").Column<string | null>;
    i18nId: import("rado").RequiredColumn<string | null>;
    locale: import("rado").Column<string | null>;
    active: import("rado").RequiredColumn<boolean | null>;
    main: import("rado").RequiredColumn<boolean | null>;
    path: import("rado").RequiredColumn<string | null>;
    data: import("rado").Column<any>;
    level: import("rado").RequiredColumn<number | null>;
    filePath: import("rado").RequiredColumn<string | null>;
    parentDir: import("rado").RequiredColumn<string | null>;
    childrenDir: import("rado").RequiredColumn<string | null>;
    /** @deprecated */
    modifiedAt: import("rado").RequiredColumn<number | null>;
    rowHash: import("rado").RequiredColumn<string | null>;
    fileHash: import("rado").RequiredColumn<string | null>;
    url: import("rado").RequiredColumn<string | null>;
    searchableText: import("rado").RequiredColumn<string | null>;
}, "Entry">): Sql<string>;
/**
 * Represents an Entry row in the database,
 * field data is available in the data column in JSON format.
 */
export type EntryRow<Data = Record<string, any>> = InferSelectModel<typeof EntryRow> & {
    data: Data;
};
