import "../chunks/chunk-U5RRZUYZ.js";

// src/core/HttpError.ts
var ErrorCode = /* @__PURE__ */ ((ErrorCode2) => {
  ErrorCode2[ErrorCode2["BadRequest"] = 400] = "BadRequest";
  ErrorCode2[ErrorCode2["Unauthorized"] = 401] = "Unauthorized";
  ErrorCode2[ErrorCode2["PaymentRequired"] = 402] = "PaymentRequired";
  ErrorCode2[ErrorCode2["Forbidden"] = 403] = "Forbidden";
  ErrorCode2[ErrorCode2["NotFound"] = 404] = "NotFound";
  ErrorCode2[ErrorCode2["MethodNotAllowed"] = 405] = "MethodNotAllowed";
  ErrorCode2[ErrorCode2["Gone"] = 410] = "Gone";
  ErrorCode2[ErrorCode2["NotAcceptable"] = 406] = "NotAcceptable";
  ErrorCode2[ErrorCode2["Timeout"] = 408] = "Timeout";
  ErrorCode2[ErrorCode2["Conflict"] = 409] = "Conflict";
  ErrorCode2[ErrorCode2["PayloadTooLarge"] = 413] = "PayloadTooLarge";
  ErrorCode2[ErrorCode2["UnsupportedMediaType"] = 415] = "UnsupportedMediaType";
  ErrorCode2[ErrorCode2["OutOfRange"] = 416] = "OutOfRange";
  ErrorCode2[ErrorCode2["ExpectationFailed"] = 417] = "ExpectationFailed";
  ErrorCode2[ErrorCode2["I_am_a_Teapot"] = 418] = "I_am_a_Teapot";
  ErrorCode2[ErrorCode2["AuthenticationTimeout"] = 419] = "AuthenticationTimeout";
  ErrorCode2[ErrorCode2["UnprocessableEntity"] = 422] = "UnprocessableEntity";
  ErrorCode2[ErrorCode2["TooManyRequests"] = 429] = "TooManyRequests";
  ErrorCode2[ErrorCode2["InternalError"] = 500] = "InternalError";
  ErrorCode2[ErrorCode2["NotImplemented"] = 501] = "NotImplemented";
  ErrorCode2[ErrorCode2["ServiceUnavailable"] = 503] = "ServiceUnavailable";
  ErrorCode2[ErrorCode2["InsufficientStorage"] = 507] = "InsufficientStorage";
  ErrorCode2[ErrorCode2["BandwidthLimitExceeded"] = 509] = "BandwidthLimitExceeded";
  return ErrorCode2;
})(ErrorCode || {});
var HttpError = class extends Error {
  code;
  constructor(code, message, options) {
    super(message ?? code.toString(), options);
    this.code = code;
  }
};
function isHttpError(error) {
  return error instanceof HttpError;
}
export {
  ErrorCode,
  HttpError,
  isHttpError
};
