import "../chunks/chunk-U5RRZUYZ.js";

// src/core/Query.ts
import { Entry } from "./Entry.js";
import { Cursor } from "./pages/Cursor.js";
import { Expr } from "./pages/Expr.js";
import { SourceType } from "./pages/ResolveData.js";
import { snippet as snippetHelper } from "./pages/Snippet.js";
function Query(type) {
  return new Cursor.Typed(type);
}
((Query2) => {
  Query2.and = Expr.and;
  Query2.or = Expr.or;
  Query2.not = (a) => Expr.create(a).not();
  Query2.is = (a, b) => Expr.create(a).is(b);
  Query2.isNot = (a, b) => Expr.create(a).isNot(b);
  Query2.isNull = (a) => Expr.create(a).isNull();
  Query2.isNotNull = (a) => Expr.create(a).isNotNull();
  Query2.isIn = (a, b) => Expr.create(a).isIn(b);
  Query2.isNotIn = (a, b) => Expr.create(a).isNotIn(b);
  Query2.isGreater = (a, b) => Expr.create(a).isGreater(b);
  Query2.isGreaterOrEqual = (a, b) => Expr.create(a).isGreaterOrEqual(b);
  Query2.isLess = (a, b) => Expr.create(a).isLess(b);
  Query2.isLessOrEqual = (a, b) => Expr.create(a).isLessOrEqual(b);
  Query2.add = (a, b, ...rest) => Expr.create(a).add(b, ...rest);
  Query2.subtract = (a, b, ...rest) => Expr.create(a).subtract(b, ...rest);
  Query2.multiply = (a, b, ...rest) => Expr.create(a).multiply(b, ...rest);
  Query2.divide = (a, b, ...rest) => Expr.create(a).divide(b, ...rest);
  Query2.remainder = (a, b) => Expr.create(a).remainder(b);
  Query2.concat = (a, b) => Expr.create(a).concat(b);
  Query2.like = (a, b) => Expr.create(a).like(b);
  Query2.at = (a, index) => Expr.create(a).at(index);
  Query2.includes = (a, value) => Expr.create(a).includes(value);
  Query2.url = Entry.url;
  Query2.path = Entry.path;
  Query2.title = Entry.title;
  Query2.id = Entry.entryId;
  Query2.parent = Entry.parent;
  Query2.type = Entry.type;
  Query2.workspace = Entry.workspace;
  Query2.root = Entry.root;
  Query2.locale = Entry.locale;
  Query2.level = Entry.level;
  Query2.entry = {
    id: Query2.id,
    type: Query2.type,
    workspace: Query2.workspace,
    root: Query2.root,
    locale: Query2.locale,
    path: Query2.path,
    title: Query2.title,
    url: Query2.url,
    parent: Query2.parent,
    level: Query2.level
  };
  Query2.where = (...where2) => Entry().where(...where2);
  Query2.whereId = (id2) => Entry().where(Entry.entryId.is(id2));
  Query2.whereUrl = (url2) => Entry().where(Entry.url.is(url2));
  Query2.wherePath = (path2) => Entry().where(Entry.path.is(path2));
  Query2.whereParent = (parentId) => Entry().where(Entry.parent.is(parentId));
  Query2.whereLocale = (locale2) => Entry().where(Entry.locale.is(locale2));
  Query2.whereWorkspace = (workspace2) => Entry().where(Entry.workspace.is(workspace2));
  Query2.whereRoot = (root2) => Entry().where(Entry.root.is(root2));
  Query2.whereType = (type2) => Entry().where(Entry.type.is(type2));
  Query2.select = (select2) => Entry().select(select2);
  Query2.search = (...searchTerms) => Entry().search(...searchTerms);
  Query2.snippet = snippetHelper;
  function children(type2, depth = 1) {
    return new Cursor.Find({
      target: { type: type2 },
      source: { type: SourceType.Children, depth }
    });
  }
  Query2.children = children;
  function parents() {
    return new Cursor.Find({
      source: { type: SourceType.Parents }
    });
  }
  Query2.parents = parents;
  function next(type2) {
    return new Cursor.Get({
      target: { type: type2 },
      source: { type: SourceType.Next }
    });
  }
  Query2.next = next;
  function previous(type2) {
    return new Cursor.Get({
      target: { type: type2 },
      source: { type: SourceType.Previous }
    });
  }
  Query2.previous = previous;
  function siblings(type2) {
    return new Cursor.Find({
      target: { type: type2 },
      source: { type: SourceType.Siblings }
    });
  }
  Query2.siblings = siblings;
  function translations(type2, includeSelf = false) {
    return new Cursor.Find({
      target: { type: type2 },
      source: { type: SourceType.Translations, includeSelf }
    });
  }
  Query2.translations = translations;
})(Query || (Query = {}));
export {
  Query
};
