import {
  array,
  boolean,
  object,
  string
} from "../chunks/chunk-AOATU4QL.js";
import "../chunks/chunk-U5RRZUYZ.js";

// src/core/Root.ts
import { Meta } from "./Meta.js";
import { Schema } from "./Schema.js";
import { Type } from "./Type.js";
var Root;
((Root2) => {
  Root2.Data = Symbol.for("@alinea/Root.Data");
  function label(root2) {
    return root2[Root2.Data].label;
  }
  Root2.label = label;
  function data(root2) {
    return root2[Root2.Data];
  }
  Root2.data = data;
  function preview(root2) {
    return root2[Root2.Data].preview;
  }
  Root2.preview = preview;
  function defaultLocale(root2) {
    return root2[Root2.Data].i18n?.locales[0];
  }
  Root2.defaultLocale = defaultLocale;
  function isRoot(value) {
    return Boolean(value && value[Root2.Data]);
  }
  Root2.isRoot = isRoot;
  function isMediaRoot(root2) {
    return Boolean(root2[Root2.Data].isMediaRoot);
  }
  Root2.isMediaRoot = isMediaRoot;
  const RootOptions = object({
    label: string,
    i18n: object({
      locales: array(string)
    }).optional,
    view: string.optional,
    isMediaRoot: boolean.optional
  });
  function validate(root2, workspaceLabel, schema) {
    const meta = data(root2);
    RootOptions(
      meta,
      `Root "${label(
        root2
      )}" in workspace "${workspaceLabel}" has invalid options`
    );
    const { contains } = meta;
    const keyOfType = Schema.typeNames(schema);
    if (contains) {
      for (const inner of contains) {
        if (typeof inner === "string") {
          if (!schema[inner])
            throw new Error(
              `Root "${label(
                root2
              )}" in workspace "${workspaceLabel}" contains "${inner}", but that Type does not exist`
            );
        } else {
          const hasType = keyOfType.has(inner);
          if (!hasType)
            throw new Error(
              `Root "${label(
                root2
              )}" in workspace "${workspaceLabel}" contains "${Type.label(
                inner
              )}", but that Type does not exist`
            );
        }
      }
    }
  }
  Root2.validate = validate;
  function referencedViews(root2) {
    const { view } = data(root2);
    return typeof view === "string" ? [view] : [];
  }
  Root2.referencedViews = referencedViews;
})(Root || (Root = {}));
function root(label, definition = {}) {
  const def = definition;
  const isOptions = "entries" in def || !def[Meta];
  const entries = isOptions ? def.entries : definition;
  const options = isOptions ? def : def[Meta];
  return {
    ...entries,
    [Root.Data]: {
      label,
      ...options
    }
  };
}
((root2) => {
  root2.meta = Meta;
})(root || (root = {}));
export {
  Root,
  root
};
