import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/media/MediaTypes.ts
import { hidden } from "alinea/field/hidden";
import { text } from "alinea/field/text/TextField";
import { IcRoundPermMedia } from "alinea/ui/icons/IcRoundPermMedia";
import { type } from "../Type.js";
var MediaLibrary = type("Media directory", {
  view: "alinea/dashboard/view/MediaExplorer#MediaExplorer",
  icon: IcRoundPermMedia,
  isContainer: true,
  contains: ["MediaLibrary"],
  fields: {
    title: hidden("Title"),
    path: hidden("Path")
  }
});
var MediaFile = type("Media file", {
  view: "alinea/dashboard/view/media/FileEntry#FileEntry",
  summaryRow: "alinea/dashboard/view/media/FileSummary#FileSummaryRow",
  summaryThumb: "alinea/dashboard/view/media/FileSummary#FileSummaryThumb",
  hidden: true,
  fields: {
    title: text("Title"),
    path: hidden("Path"),
    location: hidden("Location"),
    extension: hidden("Extension"),
    size: hidden("File size"),
    hash: hidden("Hash"),
    width: hidden("Image width"),
    height: hidden("Image height"),
    preview: hidden("Preview"),
    averageColor: hidden("Average color"),
    focus: hidden("Focus"),
    thumbHash: hidden("Blur hash")
  }
});
export {
  MediaFile,
  MediaLibrary
};
