import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/media/Summary.ts
import { Entry } from "../Entry.js";
import { Query } from "../Query.js";
function summarySelection(schema) {
  const MediaFile = schema.MediaFile;
  return {
    entryId: Entry.entryId,
    i18nId: Entry.i18nId,
    type: Entry.type,
    workspace: Entry.workspace,
    root: Entry.root,
    title: Entry.title,
    extension: MediaFile.extension,
    size: MediaFile.size,
    preview: MediaFile.preview,
    thumbHash: MediaFile.thumbHash,
    averageColor: MediaFile.averageColor,
    focus: MediaFile.focus,
    width: MediaFile.width,
    height: MediaFile.height,
    parents: Query.parents().select({
      entryId: Entry.entryId,
      i18nId: Entry.i18nId,
      title: Entry.title
    }),
    childrenAmount: Query.children().count()
  };
}
export {
  summarySelection
};
