import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/pages/CreateSelection.ts
import { isRowId } from "../util/RowId.js";
import { Tree } from "./Cursor.js";
import { ExprData, Selection, toSelection } from "./ResolveData.js";
function createSelection(input) {
  return fromInput(input);
}
function fromInput(input, parent, level = 0) {
  if (input === null || input === void 0)
    return Selection.Expr(ExprData.Value(null));
  if (input[toSelection])
    return input[toSelection]();
  if (typeof input === "function") {
    return fromInput(input.call(parent, new Tree(
      /*sourceId*/
    )), level);
  }
  if (input && typeof input === "object" && !Array.isArray(input)) {
    const keys = Object.keys(input);
    return Selection.Record(
      keys.map((key) => {
        if (isRowId(key))
          return [input[key]];
        return [key, fromInput(input[key], input, level + 1)];
      })
    );
  }
  return Selection.Expr(ExprData.Value(input));
}
export {
  createSelection
};
