import {
  any,
  array,
  boolean,
  enums,
  literal,
  number,
  object,
  record,
  string,
  tuple,
  type,
  union
} from "../../chunks/chunk-AOATU4QL.js";
import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/pages/ResolveData.ts
var Selection;
((Selection2) => {
  let types;
  ((types2) => {
    class Row2 {
      type = literal("row");
      target = TargetData;
    }
    types2.Row = Row2;
    class Record2 {
      type = literal("record");
      fields = array(
        union(tuple(string, Selection2.adt), tuple(TargetData))
      );
    }
    types2.Record = Record2;
    class Cursor2 {
      type = literal("cursor");
      cursor = CursorData;
    }
    types2.Cursor = Cursor2;
    class Expr2 {
      type = literal("expr");
      expr = ExprData.adt;
      fromParent = boolean;
    }
    types2.Expr = Expr2;
    class Count2 {
      type = literal("count");
    }
    types2.Count = Count2;
  })(types || (types = {}));
  function Row(target) {
    return { type: "row", target };
  }
  Selection2.Row = Row;
  function Record(fields) {
    return { type: "record", fields };
  }
  Selection2.Record = Record;
  function Cursor(cursor) {
    return { type: "cursor", cursor };
  }
  Selection2.Cursor = Cursor;
  function Expr(expr, fromParent = false) {
    return { type: "expr", expr, fromParent };
  }
  Selection2.Expr = Expr;
  function Count() {
    return { type: "count" };
  }
  Selection2.Count = Count;
  Selection2.adt = union(
    types.Row,
    types.Record,
    types.Cursor,
    types.Expr,
    types.Count
  );
})(Selection || (Selection = {}));
var OrderDirection = /* @__PURE__ */ ((OrderDirection2) => {
  OrderDirection2["Asc"] = "Asc";
  OrderDirection2["Desc"] = "Desc";
  return OrderDirection2;
})(OrderDirection || {});
var OrderBy = object(
  class {
    expr = ExprData.adt;
    order = enums(OrderDirection);
  }
);
var CursorData = object(
  class {
    target = TargetData.optional;
    where = ExprData.adt.optional;
    searchTerms = array(string).optional;
    skip = number.optional;
    take = number.optional;
    orderBy = array(OrderBy).optional;
    groupBy = array(ExprData.adt).optional;
    select = Selection.adt.optional;
    first = boolean.optional;
    source = CursorSource.optional;
  }
);
var SourceType = /* @__PURE__ */ ((SourceType2) => {
  SourceType2["Children"] = "Children";
  SourceType2["Siblings"] = "Siblings";
  SourceType2["Translations"] = "Translations";
  SourceType2["Parents"] = "Parents";
  SourceType2["Parent"] = "Parent";
  SourceType2["Next"] = "Next";
  SourceType2["Previous"] = "Previous";
  return SourceType2;
})(SourceType || {});
var CursorSource = object(
  class {
    type = enums(SourceType);
    // id = string
    depth = number.optional;
    includeSelf = boolean.optional;
  }
);
var UnaryOp = /* @__PURE__ */ ((UnaryOp2) => {
  UnaryOp2["Not"] = "Not";
  UnaryOp2["IsNull"] = "IsNull";
  return UnaryOp2;
})(UnaryOp || {});
var BinaryOp = /* @__PURE__ */ ((BinaryOp2) => {
  BinaryOp2["Add"] = "Add";
  BinaryOp2["Subt"] = "Subt";
  BinaryOp2["Mult"] = "Mult";
  BinaryOp2["Mod"] = "Mod";
  BinaryOp2["Div"] = "Div";
  BinaryOp2["Greater"] = "Greater";
  BinaryOp2["GreaterOrEqual"] = "GreaterOrEqual";
  BinaryOp2["Less"] = "Less";
  BinaryOp2["LessOrEqual"] = "LessOrEqual";
  BinaryOp2["Equals"] = "Equals";
  BinaryOp2["NotEquals"] = "NotEquals";
  BinaryOp2["And"] = "And";
  BinaryOp2["Or"] = "Or";
  BinaryOp2["Like"] = "Like";
  BinaryOp2["In"] = "In";
  BinaryOp2["NotIn"] = "NotIn";
  BinaryOp2["Concat"] = "Concat";
  return BinaryOp2;
})(BinaryOp || {});
var ExprData;
((ExprData2) => {
  let types;
  ((types2) => {
    class UnOp2 {
      type = literal("unop");
      op = enums(UnaryOp);
      expr = ExprData2.adt;
    }
    types2.UnOp = UnOp2;
    class BinOp2 {
      type = literal("binop");
      a = ExprData2.adt;
      op = enums(BinaryOp);
      b = ExprData2.adt;
    }
    types2.BinOp = BinOp2;
    class Field2 {
      type = literal("field");
      target = TargetData;
      field = string;
    }
    types2.Field = Field2;
    class Access2 {
      type = literal("access");
      expr = ExprData2.adt;
      field = string;
    }
    types2.Access = Access2;
    class Value2 {
      type = literal("value");
      value = any;
    }
    types2.Value = Value2;
    class Record2 {
      type = literal("record");
      fields = record(ExprData2.adt);
    }
    types2.Record = Record2;
    class Call2 {
      type = literal("call");
      method = string;
      args = array(ExprData2.adt);
    }
    types2.Call = Call2;
  })(types || (types = {}));
  function UnOp(op, expr) {
    return { type: "unop", op, expr };
  }
  ExprData2.UnOp = UnOp;
  function BinOp(a, op, b) {
    return { type: "binop", a, op, b };
  }
  ExprData2.BinOp = BinOp;
  function Field(target, field) {
    return { type: "field", target, field };
  }
  ExprData2.Field = Field;
  function Access(expr, field) {
    return { type: "access", expr, field };
  }
  ExprData2.Access = Access;
  function Value(value) {
    return { type: "value", value };
  }
  ExprData2.Value = Value;
  function Record(fields) {
    return { type: "record", fields };
  }
  ExprData2.Record = Record;
  function Call(method, args) {
    return { type: "call", method, args };
  }
  ExprData2.Call = Call;
  ExprData2.adt = union(
    types.UnOp,
    types.BinOp,
    types.Field,
    types.Access,
    types.Value,
    types.Record,
    types.Call
  );
})(ExprData || (ExprData = {}));
var TT = type(
  (value) => value && typeof value === "object"
);
var TargetData = object(
  class {
    name = string.optional;
    // alias? = string.optional
    type = TT.optional;
  }
);
var toSelection = Symbol.for("@alinea/toSelection");
var toExpr = Symbol.for("@alinea/toExpr");
var targetData = Symbol.for("@alinea/targetData");
export {
  BinaryOp,
  CursorData,
  CursorSource,
  ExprData,
  OrderBy,
  OrderDirection,
  Selection,
  SourceType,
  TargetData,
  UnaryOp,
  targetData,
  toExpr,
  toSelection
};
