import { Callable } from '../util/Callable.js';
import { Cursor } from './Cursor.js';
import { EV } from './Expr.js';
import { Fields } from './Fields.js';
import { ExprData, Selection, targetData, toSelection } from './ResolveData.js';
import { TargetData } from './TargetData.js';
export declare class TargetI<Row = object> {
    get [Target.IsTarget](): true;
    get [targetData](): TargetData;
    [toSelection](): Selection.Row;
}
export interface TargetI<Row = object> extends Callable {
    (conditions?: {
        [K in keyof Row]?: EV<Row[K]>;
    }): Cursor.Find<Row>;
}
export type Target<Row> = Target.Definition<Row> & TargetI<Row>;
export declare namespace Target {
    type Definition<Row> = {
        [K in keyof Row as K extends string ? K : never]: Fields<Row[K]>;
    };
}
export declare const Target: {
    new (data: TargetData): {
        cache: any;
        data: TargetData;
        call(...input: Array<any>): Cursor.Find<unknown>;
        condition(input: Array<any>): ExprData | undefined;
        get(field: string): any;
    };
    readonly IsTarget: unique symbol;
    isTarget<T>(target: any): target is TargetI<T>;
    create<T>(data: TargetData): Target<T>;
};
