import "../../chunks/chunk-U5RRZUYZ.js";

// src/core/util/BufferToBase64.ts
import {
  Blob,
  CompressionStream,
  DecompressionStream,
  Response
} from "@alinea/iso";
var decode = (btoa2, format = "deflate") => {
  for (var blob, str = atob(btoa2), { length } = str, buffer = new Uint8Array(length), i = 0; i < length; i++)
    buffer[i] = str.charCodeAt(i);
  blob = new Blob([buffer]);
  return (format ? new Response(blob.stream().pipeThrough(new DecompressionStream(format))) : blob).arrayBuffer();
};
var encode = async (buffer, format = "deflate") => {
  for (var blob = new Blob([buffer]), res = format ? new Response(blob.stream().pipeThrough(new CompressionStream(format))) : blob, view = new Uint8Array(await res.arrayBuffer()), { fromCharCode } = String, { length } = view, out = "", c = 2e3, i = 0; i < length; i += c)
    out += fromCharCode(...view.subarray(i, i + c));
  return btoa(out);
};
export {
  decode,
  encode
};
