import { Lazy } from './Lazy.js';
export type LazyRecord<V> = Lazy<{
    [key: string]: Lazy<V>;
}>;
export declare namespace LazyRecord {
    function iterate<V>(collection: LazyRecord<V>): Array<[string, V]>;
    function concat<A, B>(a: LazyRecord<A>, b: LazyRecord<B>): LazyRecord<A & B>;
    function resolve<V>(collection: LazyRecord<V>): {
        [key: string]: V;
    };
    function keys<V>(collection: LazyRecord<V>): Array<string>;
    function get<V>(collection: LazyRecord<V>, key: string): V;
}
