export type UnionToIntersection<T> = (T extends any ? (x: T) => any : never) extends (x: infer R) => any ? R : never;
export declare function unreachable(value: never): never;
type CommonKeys<T extends object> = keyof T;
type AllKeys<T> = T extends any ? keyof T : never;
type Subtract<A, C> = A extends C ? never : A;
type NonCommonKeys<T extends object> = Subtract<AllKeys<T>, CommonKeys<T>>;
type PickType<T, K extends AllKeys<T>> = T extends {
    [k in K]?: any;
} ? T[K] : undefined;
type PickTypeOf<T, K extends string | number | symbol> = K extends AllKeys<T> ? PickType<T, K> : never;
export type Merge<T extends object> = {
    [k in CommonKeys<T>]: PickTypeOf<T, k>;
} & {
    [k in NonCommonKeys<T>]?: PickTypeOf<T, k>;
};
export type IsStrictlyAny<T> = (T extends never ? true : false) extends false ? false : true;
export type ObjectUnion<T> = {
    [K in T extends unknown ? keyof T : never]: T extends {
        [_ in K]: infer V;
    } ? V : never;
};
export type HasType = {
    type: string;
};
export type TypesOf<T> = T extends HasType ? T['type'] : string;
export type Expand<T> = {
    [K in keyof T]: T[K];
} & {};
export type UnionOfValues<T> = T[keyof T];
export {};
