import { Route, Router } from './atoms/RouterAtoms.js';
export declare const entryRoute: Route<{
    editor: {
        transition: import("jotai").PrimitiveAtom<{
            transition: import("./atoms/EntryEditorAtoms.js").EntryTransition;
            done: Promise<any>;
        } | undefined> & {
            init: {
                transition: import("./atoms/EntryEditorAtoms.js").EntryTransition;
                done: Promise<any>;
            } | undefined;
        };
        revisionId: string;
        activePhase: import("alinea/core/EntryRow").EntryPhase;
        phaseInUrl: import("jotai").Atom<import("alinea/core/EntryRow").EntryPhase | undefined>;
        selectedPhase: import("jotai").Atom<import("alinea/core/EntryRow").EntryPhase>;
        entryData: import("./atoms/EntryEditorAtoms.js").EntryData;
        editMode: import("jotai").PrimitiveAtom<import("./atoms/EntryEditorAtoms.js").EditMode> & {
            init: import("./atoms/EntryEditorAtoms.js").EditMode;
        };
        activeVersion: import("./atoms/EntryEditorAtoms.js").Version;
        type: import("alinea/alinea").Type;
        previewPayload: import("jotai").Atom<Promise<string>>;
        activeTitle: import("jotai").Atom<string>;
        hasChanges: import("jotai").PrimitiveAtom<boolean> & {
            init: boolean;
        };
        draftEntry: import("jotai").Atom<Promise<import("alinea/core/EntryRow").EntryRow>>;
        saveDraft: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        publishEdits: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        restoreRevision: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        publishDraft: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        discardDraft: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        archivePublished: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        publishArchived: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        deleteFile: import("jotai").WritableAtom<null, [], Promise<void> | undefined> & {
            init: null;
        };
        deleteMediaLibrary: import("jotai").WritableAtom<null, [], Promise<void> | undefined> & {
            init: null;
        };
        deleteArchived: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        saveTranslation: import("jotai").WritableAtom<null, [locale: string], Promise<void>> & {
            init: null;
        };
        discardEdits: import("jotai").WritableAtom<null, [], void> & {
            init: null;
        };
        isLoading: import("jotai").Atom<boolean>;
        showHistory: import("jotai").WritableAtom<boolean, [value: boolean], void>;
        revisionsAtom: import("jotai").Atom<Promise<import("alinea/backend/Backend").Revision[]>>;
        previewToken: import("jotai").Atom<Promise<string>>;
        previewRevision: import("jotai").PrimitiveAtom<{
            ref: string;
            file: string;
        } | undefined> & {
            init: {
                ref: string;
                file: string;
            } | undefined;
        };
        preview: import("alinea/core/Preview").Preview | undefined;
        form: import("jotai").Atom<import("alinea/dashboard").FormAtoms<object>>;
        view: import("alinea/core/View").View<import("./view/EntryEdit.js").EntryEditProps & {
            type: import("alinea/alinea").Type;
        }> | undefined;
        parents: Array<{
            entryId: string;
            path: string;
        }>;
        client: import("alinea/core/Connection").Connection;
        config: import("alinea/alinea").Config;
        entryId: string;
        versions: Array<import("./atoms/EntryEditorAtoms.js").Version>;
        phases: Record<import("alinea/core/EntryRow").EntryPhase, import("./atoms/EntryEditorAtoms.js").Version>;
        availablePhases: Array<import("alinea/core/EntryRow").EntryPhase>;
        translations: Array<{
            locale: string;
            entryId: string;
        }>;
        parentNeedsTranslation: boolean;
        edits: import("./atoms/Edits.js").Edits;
    } | undefined;
}>;
export declare const draftRoute: Route<{
    editor: {
        transition: import("jotai").PrimitiveAtom<{
            transition: import("./atoms/EntryEditorAtoms.js").EntryTransition;
            done: Promise<any>;
        } | undefined> & {
            init: {
                transition: import("./atoms/EntryEditorAtoms.js").EntryTransition;
                done: Promise<any>;
            } | undefined;
        };
        revisionId: string;
        activePhase: import("alinea/core/EntryRow").EntryPhase;
        phaseInUrl: import("jotai").Atom<import("alinea/core/EntryRow").EntryPhase | undefined>;
        selectedPhase: import("jotai").Atom<import("alinea/core/EntryRow").EntryPhase>;
        entryData: import("./atoms/EntryEditorAtoms.js").EntryData;
        editMode: import("jotai").PrimitiveAtom<import("./atoms/EntryEditorAtoms.js").EditMode> & {
            init: import("./atoms/EntryEditorAtoms.js").EditMode;
        };
        activeVersion: import("./atoms/EntryEditorAtoms.js").Version;
        type: import("alinea/alinea").Type;
        previewPayload: import("jotai").Atom<Promise<string>>;
        activeTitle: import("jotai").Atom<string>;
        hasChanges: import("jotai").PrimitiveAtom<boolean> & {
            init: boolean;
        };
        draftEntry: import("jotai").Atom<Promise<import("alinea/core/EntryRow").EntryRow>>;
        saveDraft: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        publishEdits: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        restoreRevision: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        publishDraft: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        discardDraft: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        archivePublished: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        publishArchived: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        deleteFile: import("jotai").WritableAtom<null, [], Promise<void> | undefined> & {
            init: null;
        };
        deleteMediaLibrary: import("jotai").WritableAtom<null, [], Promise<void> | undefined> & {
            init: null;
        };
        deleteArchived: import("jotai").WritableAtom<null, [], Promise<void>> & {
            init: null;
        };
        saveTranslation: import("jotai").WritableAtom<null, [locale: string], Promise<void>> & {
            init: null;
        };
        discardEdits: import("jotai").WritableAtom<null, [], void> & {
            init: null;
        };
        isLoading: import("jotai").Atom<boolean>;
        showHistory: import("jotai").WritableAtom<boolean, [value: boolean], void>;
        revisionsAtom: import("jotai").Atom<Promise<import("alinea/backend/Backend").Revision[]>>;
        previewToken: import("jotai").Atom<Promise<string>>;
        previewRevision: import("jotai").PrimitiveAtom<{
            ref: string;
            file: string;
        } | undefined> & {
            init: {
                ref: string;
                file: string;
            } | undefined;
        };
        preview: import("alinea/core/Preview").Preview | undefined;
        form: import("jotai").Atom<import("alinea/dashboard").FormAtoms<object>>;
        view: import("alinea/core/View").View<import("./view/EntryEdit.js").EntryEditProps & {
            type: import("alinea/alinea").Type;
        }> | undefined;
        parents: Array<{
            entryId: string;
            path: string;
        }>;
        client: import("alinea/core/Connection").Connection;
        config: import("alinea/alinea").Config;
        entryId: string;
        versions: Array<import("./atoms/EntryEditorAtoms.js").Version>;
        phases: Record<import("alinea/core/EntryRow").EntryPhase, import("./atoms/EntryEditorAtoms.js").Version>;
        availablePhases: Array<import("alinea/core/EntryRow").EntryPhase>;
        translations: Array<{
            locale: string;
            entryId: string;
        }>;
        parentNeedsTranslation: boolean;
        edits: import("./atoms/Edits.js").Edits;
    } | undefined;
}>;
export declare const editRoute: Route<{
    locale: string | undefined;
    entryId: string;
    i18nId: string;
    root: string;
    workspace: string;
} | null>;
export declare const router: Router;
