import { Field, FieldOptions } from 'alinea/core';
export declare function useField<StoredValue, QueryValue, Mutator, Options extends FieldOptions<StoredValue>>(field: Field<StoredValue, QueryValue, Mutator, Options> | string): {
    fieldKey: string;
    label: string;
    options: Awaited<Options>;
    value: Awaited<StoredValue>;
    mutator: Mutator;
    error: string | boolean | undefined;
};
export declare function useFieldKey<StoredValue, QueryValue, Mutator, Options extends FieldOptions<StoredValue>>(field: Field<StoredValue, QueryValue, Mutator, Options>): string;
export declare function useFieldOptions<StoredValue, QueryValue, Mutator, Options extends FieldOptions<StoredValue>>(field: Field<StoredValue, QueryValue, Mutator, Options>): Awaited<Options> | Awaited<Options>;
export declare function useFieldError<StoredValue, QueryValue, Mutator, Options extends FieldOptions<StoredValue>>(field: Field<StoredValue, QueryValue, Mutator, Options>): string | boolean | undefined;
export declare function useFieldValue<StoredValue, QueryValue, Mutator, Options extends FieldOptions<StoredValue>>(field: Field<StoredValue, QueryValue, Mutator, Options>): Awaited<StoredValue>;
export declare function useFieldMutator<StoredValue, QueryValue, Mutator, Options extends FieldOptions<StoredValue>>(field: Field<StoredValue, QueryValue, Mutator, Options>): Mutator;
