import { Connection } from 'alinea/core/Connection';
import { EntryRow } from 'alinea/core/EntryRow';
import { type MediaFile } from 'alinea/core/media/MediaTypes';
export declare enum UploadStatus {
    Queued = 0,
    CreatingPreview = 1,
    Uploading = 2,
    Uploaded = 3,
    Done = 4
}
export interface UploadDestination {
    entryId?: string;
    parentId?: string;
    workspace: string;
    root: string;
    directory: string;
}
export interface Upload {
    id: string;
    file: File;
    to: UploadDestination;
    status: UploadStatus;
    info?: Connection.UploadResponse;
    preview?: string;
    averageColor?: string;
    focus?: {
        x: number;
        y: number;
    };
    thumbHash?: string;
    width?: number;
    height?: number;
    result?: EntryRow<MediaFile>;
    error?: Error;
    replace?: {
        entry: EntryRow;
        entryFile: string;
    };
}
export declare function useUploads(onSelect?: (entry: EntryRow) => void): {
    upload: (files: Array<File>, to: UploadDestination, replace?: {
        entry: EntryRow;
        entryFile: string;
    }) => Promise<void[]>;
    uploads: Upload[];
};
