import {
  dist_default
} from "../../chunks/chunk-ANJZSESR.js";
import {
  useAtomValue
} from "../../chunks/chunk-WF77DMLN.js";
import "../../chunks/chunk-OBOPLPUQ.js";
import {
  useQuery
} from "../../chunks/chunk-DJKGEOOC.js";
import "../../chunks/chunk-U5RRZUYZ.js";

// src/dashboard/pages/DraftsOverview.tsx
import { Entry } from "alinea/core/Entry";
import { Button, HStack, Stack, Typo, VStack, px } from "alinea/ui";
import { IcRoundArrowForward } from "alinea/ui/icons/IcRoundArrowForward";
import { graphAtom } from "../atoms/DbAtoms.js";
import { useNav } from "../hook/UseNav.js";
import { useWorkspace } from "../hook/UseWorkspace.js";
import { EntryEdit } from "../view/EntryEdit.js";
import { Sidebar } from "../view/Sidebar.js";

// src/dashboard/pages/DraftsOverview.module.scss
var DraftsOverview_module_default = {
  "root": "alinea-DraftsOverview",
  "root-inner": "alinea-DraftsOverview-inner",
  "rootInner": "alinea-DraftsOverview-inner",
  "root-header": "alinea-DraftsOverview-header",
  "rootHeader": "alinea-DraftsOverview-header",
  "root-list": "alinea-DraftsOverview-list",
  "rootList": "alinea-DraftsOverview-list",
  "diff": "alinea-DraftsOverview-diff"
};

// src/dashboard/pages/DraftsOverview.tsx
import { Fragment, jsx, jsxs } from "react/jsx-runtime";
var styles = dist_default(DraftsOverview_module_default);
function DraftsOverview({ editor }) {
  const graph = useAtomValue(graphAtom);
  const nav = useNav();
  const workspace = useWorkspace();
  const { data, refetch } = useQuery(
    ["drafts-overview"],
    () => {
      return graph.drafts.find(Entry({ workspace: workspace.name }));
    },
    { suspense: true }
  );
  const drafts = data;
  const selected = editor?.entryId && drafts.find((d) => d.entryId === editor?.entryId);
  function handlePublish() {
  }
  return /* @__PURE__ */ jsxs(Fragment, { children: [
    /* @__PURE__ */ jsxs(Sidebar.Tree, { children: [
      /* @__PURE__ */ jsxs(HStack, { center: true, style: { padding: `${px(10)} ${px(20)}` }, children: [
        /* @__PURE__ */ jsx(Typo.H4, { flat: true, children: "DRAFTS" }),
        /* @__PURE__ */ jsx(Stack.Right, { children: /* @__PURE__ */ jsx(Button, { iconRight: IcRoundArrowForward, onClick: handlePublish, children: "Publish all" }) })
      ] }),
      /* @__PURE__ */ jsx(VStack, { children: drafts.map((draft) => {
        return /* @__PURE__ */ jsx("div", { children: draft.title }, draft.entryId);
      }) })
    ] }),
    selected && editor && /* @__PURE__ */ jsx(EntryEdit, { editor })
  ] });
}
export {
  DraftsOverview
};
