import { ComponentType, PropsWithChildren, ReactNode } from 'react';
export type LabelHeaderProps = {
    label: ReactNode;
    help?: string;
    size?: 'small' | 'medium' | 'large';
    focused?: boolean;
    icon?: ComponentType;
    shared?: boolean;
    readOnly?: boolean;
    required?: boolean;
    error?: boolean | string;
};
export declare const LabelHeader: import("react").NamedExoticComponent<LabelHeaderProps>;
export interface InputLabelProps extends PropsWithChildren {
    label?: ReactNode;
    asLabel?: boolean;
    help?: string;
    width?: number;
    inline?: boolean;
    collection?: boolean;
    focused?: boolean;
    size?: 'small' | 'medium' | 'large';
    icon?: ComponentType;
    empty?: boolean;
    shared?: boolean;
    readOnly?: boolean;
    className?: string;
    error?: boolean | string;
    required?: boolean;
}
/** Label for an input */
export declare const InputLabel: import("react").ForwardRefExoticComponent<InputLabelProps & import("react").RefAttributes<HTMLElement>>;
