import {
  dist_default
} from "../../../chunks/chunk-ANJZSESR.js";
import "../../../chunks/chunk-U5RRZUYZ.js";

// src/dashboard/view/entry/EditModeToggle.tsx
import { Icon } from "alinea/ui";
import { IcRoundEdit } from "alinea/ui/icons/IcRoundEdit";
import { MdiSourceBranch } from "alinea/ui/icons/MdiSourceBranch";

// src/dashboard/view/entry/EditModeToggle.module.scss
var EditModeToggle_module_default = {
  "root": "alinea-EditModeToggle",
  "root-switch": "alinea-EditModeToggle-switch",
  "rootSwitch": "alinea-EditModeToggle-switch",
  "is-active": "alinea-EditModeToggle-is-active",
  "isActive": "alinea-EditModeToggle-is-active"
};

// src/dashboard/view/entry/EditModeToggle.tsx
import { jsx, jsxs } from "react/jsx-runtime";
var styles = dist_default(EditModeToggle_module_default);
var EditMode = /* @__PURE__ */ ((EditMode2) => {
  EditMode2["Editing"] = "editing";
  EditMode2["Diff"] = "diff";
  return EditMode2;
})(EditMode || {});
function EditModeToggle({ mode, onChange }) {
  return /* @__PURE__ */ jsxs("div", { className: styles.root(), children: [
    /* @__PURE__ */ jsx(
      "button",
      {
        className: styles.root.switch({ active: mode === "editing" /* Editing */ }),
        onClick: () => onChange("editing" /* Editing */),
        children: /* @__PURE__ */ jsx(Icon, { icon: IcRoundEdit, title: "Edit" })
      }
    ),
    /* @__PURE__ */ jsx(
      "button",
      {
        className: styles.root.switch({ active: mode === "diff" /* Diff */ }),
        onClick: () => onChange("diff" /* Diff */),
        children: /* @__PURE__ */ jsx(Icon, { icon: MdiSourceBranch, title: "Review changes" })
      }
    )
  ] });
}
export {
  EditMode,
  EditModeToggle
};
