import type { WithoutLabel } from 'alinea/core/Field';
import { InferStoredValue } from 'alinea/core/Infer';
import { Label } from 'alinea/core/Label';
import { Type } from 'alinea/core/Type';
import type { ListRow } from 'alinea/core/shape/ListShape';
import { LinkFieldOptions } from 'alinea/field/link/LinkField';
import { EntryPickerOptions } from 'alinea/picker/entry';
import { EntryReference } from 'alinea/picker/entry/EntryReference';
export interface EntryLink<InferredFields = undefined> extends EntryReference {
    entryId: string;
    entryType: string;
    i18nId: string;
    title: string;
    path: string;
    /** @deprecated Use href */
    url: string;
    href: string;
    fields: InferredFields;
}
export declare namespace EntryLink {
    const entryId: import("alinea/core/pages/Expr").Expr<string>;
    const i18nId: import("alinea/core/pages/Expr").Expr<string>;
    const title: import("alinea/core/pages/Expr").Expr<string>;
    const entryType: import("alinea/core/pages/Expr").Expr<string>;
    const url: import("alinea/core/pages/Expr").Expr<string>;
    const href: import("alinea/core/pages/Expr").Expr<string>;
    const path: import("alinea/core/pages/Expr").Expr<string>;
}
interface EntryOptions<Fields> extends LinkFieldOptions<EntryReference & InferStoredValue<Fields>>, Omit<EntryPickerOptions<Fields>, 'label' | 'selection'> {
}
export declare function entry<Fields = undefined>(label: Label, options?: WithoutLabel<EntryOptions<Fields>>): import("alinea/field/link/LinkField").LinkField<EntryReference & InferStoredValue<Fields>, EntryLink<{ [K_1 in keyof Fields as Fields[K_1] extends import("alinea/core/pages/Expr").Expr<any> ? K_1 : never]: Fields[K_1] extends import("alinea/core/pages/Expr").Expr<infer T_1> ? T_1 : never; } extends infer T ? { [K in keyof T]: { [K_1 in keyof Fields as Fields[K_1] extends import("alinea/core/pages/Expr").Expr<any> ? K_1 : never]: Fields[K_1] extends import("alinea/core/pages/Expr").Expr<infer T_1> ? T_1 : never; }[K]; } : never>>;
export declare namespace entry {
    type EntryRow<Fields> = EntryLink<Type.Infer<Fields>> & ListRow;
    interface EntryOptions<Fields> extends LinkFieldOptions<Array<EntryReference & ListRow & InferStoredValue<Fields>>>, Omit<EntryPickerOptions<Fields>, 'label' | 'selection'> {
    }
    export function multiple<Fields = undefined>(label: Label, options?: WithoutLabel<EntryOptions<Fields>>): import("alinea/field/link/LinkField").LinksField<EntryReference & ListRow, EntryRow<Fields>>;
    export {};
}
export {};
