import type { WithoutLabel } from 'alinea/core/Field';
import { Label } from 'alinea/core/Label';
import { Reference } from 'alinea/core/Reference';
import { Type } from 'alinea/core/Type';
import type { ListRow } from 'alinea/core/shape/ListShape';
import { FileLink } from 'alinea/field/link/FileLink';
import { LinkFieldOptions } from 'alinea/field/link/LinkField';
import { EntryLink, entry as entryLink } from './EntryLink.js';
import { file as fileLink } from './FileLink.js';
import { image as imageLink } from './ImageLink.js';
import { UrlLink, url as urlLink } from './UrlLink.js';
export type AnyLink<InferredFields> = EntryLink<InferredFields> | UrlLink<InferredFields> | FileLink<InferredFields>;
export interface LinkOptions<Definition, Row> extends LinkFieldOptions<Row> {
    fields?: Definition | Type<Definition>;
}
export declare function link<Fields>(label: Label, options?: WithoutLabel<LinkOptions<Fields, Reference>>): import("alinea/field/link/LinkField").LinkField<Reference, AnyLink<{ [K_1 in keyof Fields as Fields[K_1] extends import("alinea/core/pages/Expr").Expr<any> ? K_1 : never]: Fields[K_1] extends import("alinea/core/pages/Expr").Expr<infer T_1> ? T_1 : never; } extends infer T ? { [K in keyof T]: { [K_1 in keyof Fields as Fields[K_1] extends import("alinea/core/pages/Expr").Expr<any> ? K_1 : never]: Fields[K_1] extends import("alinea/core/pages/Expr").Expr<infer T_1> ? T_1 : never; }[K]; } : never>>;
export declare namespace link {
    function multiple<Fields>(label: Label, options?: WithoutLabel<LinkOptions<Fields, Array<ListRow>>>): import("alinea/field/link/LinkField").LinksField<ListRow, AnyLink<{ [K_1 in keyof Fields as Fields[K_1] extends import("alinea/core/pages/Expr").Expr<any> ? K_1 : never]: Fields[K_1] extends import("alinea/core/pages/Expr").Expr<infer T_1> ? T_1 : never; } extends infer T ? { [K in keyof T]: { [K_1 in keyof Fields as Fields[K_1] extends import("alinea/core/pages/Expr").Expr<any> ? K_1 : never]: Fields[K_1] extends import("alinea/core/pages/Expr").Expr<infer T_1> ? T_1 : never; }[K]; } : never>>;
    /** @deprecated Use Field.image */
    const image: typeof imageLink;
    /** @deprecated Use Field.entry */
    const entry: typeof entryLink;
    /** @deprecated Use Field.file */
    const file: typeof fileLink;
    /** @deprecated Use Field.url */
    const url: typeof urlLink;
}
