import "../../chunks/chunk-U5RRZUYZ.js";

// src/field/link/Link.ts
import { filePicker } from "alinea/field/link/FileLink";
import {
  createLink,
  createLinks
} from "alinea/field/link/LinkField";
import { entryPicker } from "alinea/picker/entry";
import { urlPicker } from "alinea/picker/url";
import { EntryLink, entry as entryLink } from "./EntryLink.js";
import { file as fileLink } from "./FileLink.js";
import { image as imageLink } from "./ImageLink.js";
import { url as urlLink } from "./UrlLink.js";
function link(label, options = {}) {
  return createLink(label, {
    ...options,
    pickers: {
      entry: entryPicker({
        ...options,
        title: "Select a page",
        max: 1,
        selection: EntryLink
      }),
      url: urlPicker(options),
      file: filePicker(false, options)
    }
  });
}
((link2) => {
  function multiple(label, options = {}) {
    return createLinks(label, {
      ...options,
      pickers: {
        entry: entryPicker({
          ...options,
          title: "Select a page",
          selection: EntryLink
        }),
        url: urlPicker(options),
        file: filePicker(true, options)
      }
    });
  }
  link2.multiple = multiple;
  link2.image = imageLink;
  link2.entry = entryLink;
  link2.file = fileLink;
  link2.url = urlLink;
})(link || (link = {}));
export {
  link
};
