import type { FieldOptions, WithoutLabel } from 'alinea/core';
import { Type } from 'alinea/core/Type';
import { RecordField } from 'alinea/core/field/RecordField';
import { ImageField } from 'alinea/field/link';
import { ObjectField } from 'alinea/field/object';
import { TextField } from 'alinea/field/text';
export interface MetadataOptions extends FieldOptions<Type.Infer<MetadataFields>> {
    inferTitleFrom?: string;
    inferDescriptionFrom?: string;
    inferImageFrom?: string;
}
export interface MetadataFields {
    title: TextField;
    description: TextField;
    openGraph: ObjectField<{
        siteName: TextField;
        image: ImageField;
        title: TextField;
        description: TextField;
    }>;
}
export declare class MetadataField extends RecordField<Type.Infer<MetadataFields>, MetadataOptions & {
    fields: Type<MetadataFields>;
}> {
}
export declare function metadata(label?: string, options?: WithoutLabel<MetadataOptions>): MetadataField;
