import "../../chunks/chunk-U5RRZUYZ.js";

// src/field/metadata/MetadataField.ts
import { type } from "alinea/core/Type";
import { RecordField } from "alinea/core/field/RecordField";
import { image } from "alinea/field/link";
import { object } from "alinea/field/object";
import { text } from "alinea/field/text";
var MetadataField = class extends RecordField {
};
function metadata(label = "Metadata", options = {}) {
  const fields = type("Fields", {
    fields: {
      title: text("Title", { width: 0.5 }),
      description: text("Description", { multiline: true }),
      openGraph: object("Open graph", {
        fields: {
          siteName: text("Site name", { width: 0.25 }),
          image: image("Image", {
            width: 0.75,
            help: "Recommended size: 1200 x 630 pixels"
          }),
          title: text("Title"),
          description: text("Description", { multiline: true })
        }
      })
    }
  });
  return new MetadataField(fields, {
    options: { label, ...options, fields },
    view: "alinea/field/metadata/MetadataField.view#MetadataInput"
  });
}
export {
  MetadataField,
  metadata
};
