import { Mark } from '@tiptap/core';
export interface SmallOptions {
    HTMLAttributes: Record<string, any>;
}
declare module '@tiptap/core' {
    interface Commands<ReturnType> {
        small: {
            /**
             * Set a small mark
             */
            setSmall: () => ReturnType;
            /**
             * Toggle a small mark
             */
            toggleSmall: () => ReturnType;
            /**
             * Unset a small mark
             */
            unsetSmall: () => ReturnType;
        };
    }
}
declare const Small: Mark<SmallOptions, any>;
export default Small;
