import {
  dist_default
} from "../../chunks/chunk-ANJZSESR.js";
import "../../chunks/chunk-U5RRZUYZ.js";

// src/field/time/TimeField.view.tsx
import { useField } from "alinea/dashboard/editor/UseField";
import { InputLabel } from "alinea/dashboard/view/InputLabel";
import { IcRoundDateRange } from "alinea/ui/icons/IcRoundDateRange";

// src/field/time/TimeField.module.scss
var TimeField_module_default = {
  "root-input": "alinea-TimeField-input",
  "rootInput": "alinea-TimeField-input"
};

// src/field/time/TimeField.view.tsx
import { jsx } from "react/jsx-runtime";
var styles = dist_default(TimeField_module_default);
function TimeInput({ field }) {
  const { options, value, mutator, error } = useField(field);
  const { minValue, maxValue, readOnly, step, autoFocus } = options;
  return /* @__PURE__ */ jsx(InputLabel, { asLabel: true, ...options, error, icon: IcRoundDateRange, children: /* @__PURE__ */ jsx(
    "input",
    {
      className: styles.root.input(),
      type: "time",
      value: value ?? "",
      onChange: (e) => mutator(e.currentTarget.value),
      autoFocus,
      readOnly,
      min: minValue,
      max: maxValue,
      step: step || 60
    }
  ) });
}
export {
  TimeInput
};
