import "../../chunks/chunk-U5RRZUYZ.js";

// src/picker/entry/EntryPicker.ts
import { Reference } from "alinea/core/Reference";
import { Type, type } from "alinea/core/Type";
import { ListRow } from "alinea/core/shape/ListShape";
import { RecordShape } from "alinea/core/shape/RecordShape";
import { ScalarShape } from "alinea/core/shape/ScalarShape";
import { assign, keys } from "alinea/core/util/Objects";
import { EntryReference } from "./EntryReference.js";
function entryPicker(options) {
  const fieldType = Type.isType(options.fields) ? options.fields : options.fields && type({ fields: options.fields });
  const extra = fieldType && Type.shape(fieldType);
  return {
    shape: new RecordShape("Entry", {
      [Reference.id]: new ScalarShape("Id"),
      [Reference.type]: new ScalarShape("Type"),
      [EntryReference.entry]: new ScalarShape("Entry")
    }).concat(extra),
    fields: fieldType,
    label: options.label || "Page link",
    handlesMultiple: true,
    options,
    async postProcess(row, loader) {
      const {
        [Reference.id]: id,
        [Reference.type]: type2,
        [EntryReference.entry]: entryId,
        [ListRow.index]: index,
        ...fields
      } = row;
      for (const key of keys(fields))
        delete row[key];
      row.fields = fields;
      if (!entryId)
        return;
      const linkIds = [entryId];
      if (!options.selection)
        return;
      const [extra2] = await loader.resolveLinks(options.selection, linkIds);
      assign(row, extra2);
    }
  };
}
export {
  entryPicker
};
