import "../chunks/chunk-U5RRZUYZ.js";

// src/preview/PreviewCookies.ts
import { chunkCookieValue, parseChunkedCookies } from "./ChunkCookieValue.js";
var PREVIEW_COOKIE_NAME = "@a/p";
var MAX_CHUNKS = 4;
async function setPreviewCookies(payload, expiresIn = 1e4) {
  const chunks = chunkCookieValue(PREVIEW_COOKIE_NAME, payload);
  if (chunks.length > MAX_CHUNKS)
    return false;
  try {
    const expiry = new Date(Date.now() + expiresIn);
    for (const { name, value } of chunks)
      document.cookie = `${name}=${value};expires=${expiry.toUTCString()}`;
    return true;
  } catch {
    return false;
  }
}
function getPreviewPayloadFromCookies(allCookies) {
  return parseChunkedCookies(PREVIEW_COOKIE_NAME, allCookies);
}
export {
  PREVIEW_COOKIE_NAME,
  getPreviewPayloadFromCookies,
  setPreviewCookies
};
