import {
  createDecoder,
  createEncoder,
  readVarString,
  readVarUint8Array,
  toUint8Array,
  writeVarString,
  writeVarUint8Array
} from "../chunks/chunk-FFKU477P.js";
import "../chunks/chunk-BRTZLYIM.js";
import "../chunks/chunk-U5RRZUYZ.js";

// src/preview/PreviewPayload.ts
import { decode, encode } from "alinea/core/util/BufferToBase64";
function encodePreviewPayload(update) {
  const encoder = createEncoder();
  writeVarString(encoder, update.entryId);
  writeVarString(encoder, update.contentHash);
  writeVarString(encoder, update.phase);
  writeVarUint8Array(encoder, update.update);
  return encode(toUint8Array(encoder));
}
async function decodePreviewPayload(payload) {
  const decoder = createDecoder(new Uint8Array(await decode(payload)));
  return {
    entryId: readVarString(decoder),
    contentHash: readVarString(decoder),
    phase: readVarString(decoder),
    update: readVarUint8Array(decoder)
  };
}
export {
  decodePreviewPayload,
  encodePreviewPayload
};
