import "../chunks/chunk-U5RRZUYZ.js";

// src/ui/Avatar.tsx
import { getRandomColor } from "alinea/core/util/GetRandomColor";
import { useContrastColor } from "./hook/UseContrastColor.js";
import { px } from "./util/Units.js";
import { jsx } from "react/jsx-runtime";
function Avatar({ user }) {
  const letter = user.sub.charAt(0).toUpperCase();
  const background = getRandomColor(user.sub);
  const color = useContrastColor(background);
  return /* @__PURE__ */ jsx(
    "div",
    {
      style: {
        borderRadius: "100%",
        background,
        color,
        width: px(24),
        height: px(24),
        display: "flex",
        justifyContent: "center",
        alignItems: "center",
        fontSize: px(13),
        fontWeight: "bold"
      },
      children: /* @__PURE__ */ jsx("span", { children: letter })
    }
  );
}
export {
  Avatar
};
