import type { ComponentProps, ComponentType, ElementType, PropsWithChildren } from 'react';
export type ButtonProps<T extends ElementType> = PropsWithChildren<{
    as?: T;
    icon?: ComponentType;
    iconRight?: ComponentType;
    size?: 'small' | 'medium' | 'large';
    outline?: boolean;
} & Omit<ComponentProps<T>, 'as'>>;
export declare function Button<T extends ElementType = 'button'>({ as, children, size, icon, iconRight, outline, ...props }: ButtonProps<T>): import("react/jsx-runtime").JSX.Element;
