import { Infer } from 'alinea/core/Infer';
import { Schema } from 'alinea/core/Schema';
import { TextDoc } from 'alinea/core/TextDoc';
import { RichTextElements } from 'alinea/core/shape/RichTextShape';
import { ComponentType, ReactElement } from 'react';
export type RichTextProps<Blocks extends Schema> = {
    doc: TextDoc<Blocks>;
    text?: ComponentType<{
        children: string;
    }>;
} & {
    [K in keyof typeof RichTextElements]?: ComponentType<JSX.IntrinsicElements[K]> | ReactElement;
} & {
    [K in keyof Blocks]?: ComponentType<Infer<Blocks[K]>>;
};
export declare function RichText<Blocks extends Schema>({ doc, ...views }: RichTextProps<Blocks>): import("react/jsx-runtime").JSX.Element | null;
